package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;
import cn.com.infosec.asn1.DERUTCTime;

public class V1TBSCertificateGenerator {
   DERTaggedObject version;
   DERInteger serialNumber;
   AlgorithmIdentifier signature;
   X509Name issuer;
   Time startDate;
   Time endDate;
   X509Name subject;
   SubjectPublicKeyInfo subjectPublicKeyInfo;

   public V1TBSCertificateGenerator() {
      V1TBSCertificateGenerator var10000 = this;
      super();
      DERTaggedObject var2;
      DERTaggedObject var10001 = var2 = new DERTaggedObject;
      DERInteger var1;
      var1 = new DERInteger.<init>(0);
      var10001.<init>(0, var1);
      var10000.version = var2;
   }

   public void setSerialNumber(DERInteger serialNumber) {
      this.serialNumber = serialNumber;
   }

   public void setSignature(AlgorithmIdentifier signature) {
      this.signature = signature;
   }

   public void setIssuer(X509Name issuer) {
      this.issuer = issuer;
   }

   public void setStartDate(Time startDate) {
      this.startDate = startDate;
   }

   public void setStartDate(DERUTCTime startDate) {
      V1TBSCertificateGenerator var10000 = this;
      Time var2;
      var2 = new Time.<init>((DERObject)startDate);
      var10000.startDate = var2;
   }

   public void setEndDate(Time endDate) {
      this.endDate = endDate;
   }

   public void setEndDate(DERUTCTime endDate) {
      V1TBSCertificateGenerator var10000 = this;
      Time var2;
      var2 = new Time.<init>((DERObject)endDate);
      var10000.endDate = var2;
   }

   public void setSubject(X509Name subject) {
      this.subject = subject;
   }

   public void setSubjectPublicKeyInfo(SubjectPublicKeyInfo pubKeyInfo) {
      this.subjectPublicKeyInfo = pubKeyInfo;
   }

   public TBSCertificateStructure generateTBSCertificate() {
      if (this.serialNumber != null && this.signature != null && this.issuer != null && this.startDate != null && this.endDate != null && this.subject != null && this.subjectPublicKeyInfo != null) {
         ASN1EncodableVector var1;
         ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
         var1.<init>();
         var1.add(this.serialNumber);
         var1.add(this.signature);
         var1.add(this.issuer);
         ASN1EncodableVector var2;
         ASN1EncodableVector var10005 = var2 = new ASN1EncodableVector;
         var2.<init>();
         var2.add(this.startDate);
         var10005.add(this.endDate);
         var1.add(new DERSequence(var2));
         var1.add(this.subject);
         var10000.add(this.subjectPublicKeyInfo);
         return new TBSCertificateStructure(new DERSequence(var1));
      } else {
         throw new IllegalStateException("not all mandatory fields set in V1 TBScertificate generator");
      }
   }
}
